
import random


#Used to create cards in a standard playing deck
class Card:
    def __init__(self, suit, face):
        self.suit = suit
        self.face = face

#Used to keep track of players, their scores and the cards in hand
class Player:
    def __init__(self, name, player_hand):
        self.name = name
        self.player_hand = []

    #points = point value of cards in a player hand, score = number of rounds won
    points = 0
    score = 0

#Takes a card out of the deck and puts it in player hand
def deal_card(player, deck):
    card_index = random.randrange(len(deck))
    player.player_hand.append(deck[card_index])
    deck.pop(card_index)


#Plays 1 round of BlackJack
def play_round():
    print("The dealer deals two cards to every player.")

    #Resets player hand value every round
    player1.points = 0
    player2.points = 0

    #game deck
    deck = []

    #suits/faces are used to compare cards and find their point values
    suits = ["Hearts", "Diamonds", "Clubs", "Spades"]
    faces = ["Ace", "2", "3", "4", "5", "6", "7", "8", "9", "10", "Jack", "Queen", "King"]

    #creates the game deck
    for a in suits:
        for b in faces:
            deck.append(Card(a, b))

    #Deals a card to player 1 and gives player 1 corresponding points based on the card they are dealt
    deal_card(player1, deck)
    print(player1.name + " gets a " + player1.player_hand[0].face + " of " + player1.player_hand[0].suit)
    for y in range(13):
        if player1.player_hand[0].face == faces[y]:
            if y < 10:
                player1.points += y + 1
            else:
                player1.points += 10

    #Card and points for player 2
    deal_card(player2, deck)
    print(player2.name + " gets a " + player2.player_hand[0].face + " of " + player2.player_hand[0].suit)
    for y in range(13):
        if player2.player_hand[0].face == faces[y]:
            if y < 10:
                player2.points += y + 1
            else:
                player2.points += 10

    # Card and points for dealer
    deal_card(dealer, deck)
    print(dealer.name + " gets a " + dealer.player_hand[0].face + " of " + dealer.player_hand[0].suit)
    for y in range(13):
        if dealer.player_hand[0].face == faces[y]:
            if y < 10:
                dealer.points += y + 1
            else:
                dealer.points += 10

    print("\n")

    # Card and points for player 1
    deal_card(player1, deck)
    print(player1.name + " gets a " + player1.player_hand[1].face + " of " + player1.player_hand[1].suit)
    for y in range(13):
        if player1.player_hand[1].face == faces[y]:
            if y < 10:
                player1.points += y + 1
            else:
                player1.points += 10

    # Card and points for player 2
    deal_card(player2, deck)
    print(player2.name + " gets a " + player2.player_hand[1].face + " of " + player2.player_hand[1].suit)
    for y in range(13):
        if player2.player_hand[1].face == faces[y]:
            if y < 10:
                player2.points += y + 1
            else:
                player2.points += 10

    # Card and points for dealer
    deal_card(dealer, deck)
    print("The dealer gets a face down card.")
    for y in range(13):
        if dealer.player_hand[1].face == faces[y]:
            if y < 10:
                dealer.points += y + 1
            else:
                dealer.points += 10

    #keeps track of index of hit cards
    player1hit = 1
    player2hit = 1
    dealerhit = 1

    print("\n")


    #while loop controls adding cards to player hand and assigning point values
    while input(player1.name + " do you want to hit? (y/n): ") == "y":
        deal_card(player1, deck)
        player1hit += 1
        print(player1.name + " gets a " + player1.player_hand[player1hit].face + " of " + player1.player_hand[player1hit].suit)

        #assigns points to player based on card added to hand
        for y in range(13):
            if player1.player_hand[player1hit].face == faces[y]:
                if y < 10:
                    player1.points += y + 1
                else:
                    player1.points += 10

        #busts the player
        if player1.points > 21:
            print(player1.name + " busts.")
            break

    print("\n")

    #adds cards and assigns point values to player
    while input(player2.name + " do you want to hit? (y/n): ") == "y":
        deal_card(player2, deck)
        player2hit += 1
        print(player2.name + " gets a " + player2.player_hand[player2hit].face + " of " + player2.player_hand[
            player2hit].suit)

        #assigns points to player
        for y in range(13):
            if player2.player_hand[player2hit].face == faces[y]:
                if y < 10:
                    player2.points += y + 1
                else:
                    player2.points += 10

        #busts the player
        if player2.points > 21:
            print(player2.name + " busts.")
            break

    print("\n")

    print("The dealer's face down card is a " + dealer.player_hand[1].face + " of " + dealer.player_hand[1].suit)

    #dealer htis until he busts or has at least 17 points
    while dealer.points < 17:
        deal_card(dealer, deck)
        dealerhit += 1
        print("The dealer gets a " + dealer.player_hand[dealerhit].face + " of " + dealer.player_hand[
            dealerhit].suit)

        #gives the dealer points based on cards added to hand
        for y in range(13):
            if dealer.player_hand[dealerhit].face == faces[y]:
                if y < 10:
                    dealer.points += y + 1
                else:
                    dealer.points += 10

        #busts dealer or stops the dealer from getting cards
        if dealer.points < 22:
            print("The dealer stops at " + str(dealer.points) + " points.")
        else:
            print("The dealer busts.")

    print(player1.name + " has : " + str(player1.points) + " points.")
    print(player2.name + " has : " + str(player2.points) + " points.")
    print("\n")


    #Last two if statements print the players that won and assigns them a score for winning if they won
    if (dealer.points < player1.points or dealer.points > 21) and player1.points < 22:
        print(player1.name + " wins a round.")
        player1.score += 1

    if (dealer.points < player2.points or dealer.points > 21) and player2.points < 22:
        print(player2.name + " wins a round.")
        player2.score += 1



#main program that plays all of the rounds and creates the player objects
print("Welcome to BlackJack!")

player1 = Player(input("Player 1 please enter your name: "), None)
player2 = Player(input("Player 2 please enter your name: "), None)
dealer = Player("Dealer", None)

#plays as many rounds of BlackJack as the players want
for x in range(int(input("Please enter the number of BlackJack rounds you want to play: "))):
    play_round()

print("\n")
print(player1.name + " has a score of: " + str(player1.score))
print(player2.name + " has a score of: " + str(player2.score))
print("\n")

#Determines the winner of blackjack
if player1.score > player2.score:
    print(player1.name + " wins BlackJack!")
elif player1.score < player2.score:
    print(player2.name + " wins BlackJack!")
else:
    print("The game ends in a tie!")